import agente
import random
import rpy

### MONDO, creo gli agenti, calcolo le variabili ambientali

n = 100
crossp = 0.5
mutationp = 0.002
t = 200
## costi variabili delle imprese variabile casuale con media 1. vedi agenti.py line 18
productionHistory = []
optimumProductionList = []
initialSeed = 123456
    
def setup(n):
    global listaAgenti
    listaAgenti=[]
    for i in range(n):
        a = agente.agent()
        listaAgenti.append(a)

    return listaAgenti


def run(t, crossp, mutationp, listaAgenti, n):
    
    for time in range(t):

        
        
        random.shuffle(listaAgenti)
        totalProduction = 0
        for i in listaAgenti:
            totalProduction += i.strategy.y

        p = 5 - (5*n**-1)*totalProduction ## prezzo
        print time, p, totalProduction, totalProduction * n ** -1

        for i in listaAgenti:
            i.computeFitnessProb(p,i.strategies, i.beta)
            listaSelected = i.selection(i.strategies)
            listaSelected = i.crossOver(listaSelected, crossp)
            listaSelected = i.mutation(listaSelected, mutationp)
            strategies = i.updateStrategies(listaSelected, i.strategies)
            i.chooseStrategy(p, strategies, i.beta)

        graphics(p, totalProduction, n)

         
def graphics(p, totalProduction, n):

    

    a = 5 * (2 * 1 + 5)**-1
    meanProduction = totalProduction * n ** -1

    productionHistory.append(meanProduction)
    optimumProductionList.append(a)
    
    mean = rpy.r.ts(productionHistory)
    opt = rpy.r.ts(optimumProductionList)

    rpy.r.ts_plot(mean, type='l', ylim=(0,1), xlab='time', ylab='mean production')
    rpy.r.points(opt, col='black')

random.seed(initialSeed)   
setup(n)
run(t, crossp, mutationp, listaAgenti, n)

